summaryrefslogtreecommitdiff
path: root/dmenuumount
diff options
context:
space:
mode:
authorzachir <zachir@librem.one>2022-10-09 01:10:41 -0500
committerzachir <zachir@librem.one>2022-10-09 01:10:41 -0500
commit91cdbd9be0d677c8a832e85de9d55aecf2c236fd (patch)
tree9d43e1514d70f8cdd7ac82c6adc92e2583456780 /dmenuumount
initialize repo
Diffstat (limited to 'dmenuumount')
-rwxr-xr-xdmenuumount44
1 files changed, 44 insertions, 0 deletions
diff --git a/dmenuumount b/dmenuumount
new file mode 100755
index 0000000..0584cb4
--- /dev/null
+++ b/dmenuumount
@@ -0,0 +1,44 @@
+#!/bin/sh
+
+# A dmenu prompt to unmount drives.
+# Provides you with mounted partitions, select one to unmount.
+# Drives mounted at /, /boot and /home will not be options to unmount.
+
+unmountusb() {
+ [ -z "$drives" ] && exit
+ chosen="$(echo "$drives" | dmenu -p "Unmount which drive?")" || exit 1
+ chosen="$(echo "$chosen" | awk '{print $1}')"
+ [ -z "$chosen" ] && exit
+ doas umount "$chosen" && notify-send "💻 USB unmounting" "$chosen unmounted."
+ }
+
+unmountandroid() { \
+ chosen="$(awk '/simple-mtpfs/ {print $2}' /etc/mtab | dmenu -p "Unmount which device?")" || exit 1
+ [ -z "$chosen" ] && exit
+ doas umount -l "$chosen" && notify-send "🤖 Android unmounting" "$chosen unmounted."
+ }
+
+asktype() { \
+ choice="$(printf "USB\\nAndroid" | dmenu -p "Unmount a USB drive or Android device?")" || exit 1
+ case "$choice" in
+ USB) unmountusb ;;
+ Android) unmountandroid ;;
+ esac
+ }
+
+drives=$(lsblk -nrpo "name,type,size,mountpoint" | awk '$4!~/\/boot|\/efi|\/home$|SWAP/&&length($4)>1{printf "%s (%s)\n",$4,$3}')
+
+if ! grep simple-mtpfs /etc/mtab; then
+ [ -z "$drives" ] && echo "No drives to unmount." && exit
+ echo "Unmountable USB drive detected."
+ unmountusb
+else
+ if [ -z "$drives" ]
+ then
+ echo "Unmountable Android device detected."
+ unmountandroid
+ else
+ echo "Unmountable USB drive(s) and Android device(s) detected."
+ asktype
+ fi
+fi